#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import commands
import os
import os.path
import logging
import logging.config
import tarfile
import subprocess
import shutil
import random
import time
#import traceback
try:
    import pygtk
    pygtk.require("2.0")
except:
    pass
try:
    import gtk
except:
    sys.exit(1)

LOGLEVEL = logging.DEBUG
UBUNTU_VERSION=0

__author__="kaoru"
__date__ ="$2010/07/03 6:59:12$"

xml_data="""<?xml version="1.0"?>
<interface>
  <requires lib="gtk+" version="2.16"/>
  <!-- interface-naming-policy project-wide -->
  <object class="GtkDialog" id="MoeSetup">
    <property name="visible">True</property>
    <property name="border_width">5</property>
    <property name="title" translatable="yes">moe setup</property>
    <property name="resizable">False</property>
    <property name="window_position">center</property>
    <property name="type_hint">normal</property>
    <property name="has_separator">False</property>
    <child internal-child="vbox">
      <object class="GtkVBox" id="dialog-vbox1">
        <property name="visible">True</property>
        <property name="spacing">2</property>
        <child>
          <object class="GtkVBox" id="vbox1">
            <property name="visible">True</property>
            <child>
              <object class="GtkLabel" id="label1">
                <property name="visible">True</property>
                <property name="label" translatable="yes">moebuntu setup</property>
                <attributes>
                  <attribute name="size" value="14000"/>
                </attributes>
              </object>
              <packing>
                <property name="position">0</property>
              </packing>
            </child>
            <child>
              <object class="GtkLabel" id="label2">
                <property name="visible">True</property>
                <property name="xalign">0</property>
                <property name="label" translatable="yes">Select the Installing Desktop Theme file (.tar.gz)
*The name of the uncompressed folder must be the same as the archive.</property>
              </object>
              <packing>
                <property name="position">1</property>
              </packing>
            </child>
            <child>
              <object class="GtkFileChooserButton" id="bfcThemeFile">
                <property name="visible">True</property>
                <property name="create_folders">False</property>
                <property name="preview_widget_active">False</property>
                <property name="filter">tarFilter</property>
                <property name="title" translatable="yes">Select the Theme file</property>
              </object>
              <packing>
                <property name="position">2</property>
              </packing>
            </child>
            <child>
              <object class="GtkLabel" id="label3">
                <property name="visible">True</property>
                <property name="xalign">0</property>
                <property name="label" translatable="yes">Select the Icon Theme Set file (.tar.gz)
*The name of the uncompressed folder must be the same as the archive.</property>
              </object>
              <packing>
                <property name="position">3</property>
              </packing>
            </child>
            <child>
              <object class="GtkFileChooserButton" id="bfcIconThemeFile">
                <property name="visible">True</property>
                <property name="create_folders">False</property>
                <property name="preview_widget_active">False</property>
                <property name="filter">tarFilter</property>
                <property name="title" translatable="yes">Select the Icon Theme file</property>
              </object>
              <packing>
                <property name="position">4</property>
              </packing>
            </child>
            <child>
              <object class="GtkLabel" id="label6">
                <property name="visible">True</property>
                <property name="xalign">0</property>
                <property name="label" translatable="yes">Select the  Moe Wallpaper for Background.(.jpg/.png)</property>
              </object>
              <packing>
                <property name="position">5</property>
              </packing>
            </child>
            <child>
              <object class="GtkFileChooserButton" id="bfcWallPaperFile">
                <property name="visible">True</property>
                <property name="create_folders">False</property>
                <property name="filter">pictFilter</property>
              </object>
              <packing>
                <property name="position">6</property>
              </packing>
            </child>
            <child>
              <object class="GtkLabel" id="label4">
                <property name="visible">True</property>
                <property name="xalign">0</property>
                <property name="label" translatable="yes">Select the Pattern Tile or Picture for File Manager (Nautilus) Window (.jpg/.png)</property>
              </object>
              <packing>
                <property name="position">7</property>
              </packing>
            </child>
            <child>
              <object class="GtkFileChooserButton" id="bfcNBGFile">
                <property name="visible">True</property>
                <property name="create_folders">False</property>
                <property name="filter">pictFilter</property>
              </object>
              <packing>
                <property name="position">8</property>
              </packing>
            </child>
            <child>
              <object class="GtkLabel" id="label5">
                <property name="visible">True</property>
                <property name="xalign">0</property>
                <property name="label" translatable="yes">Select the Sound Theme File (.tar.gz)
*The name of the uncompressed folder must be the same as the archive.</property>
              </object>
              <packing>
                <property name="position">9</property>
              </packing>
            </child>
            <child>
              <object class="GtkFileChooserButton" id="bfcSoundThemeFile">
                <property name="visible">True</property>
                <property name="create_folders">False</property>
                <property name="filter">tarFilter</property>
              </object>
              <packing>
                <property name="position">10</property>
              </packing>
            </child>
            <child>
              <object class="GtkLabel" id="label7">
                <property name="visible">True</property>
                <property name="xalign">0</property>
                <property name="label" translatable="yes">Select the Installing Font File (tar.gz/zip)
*This is Install only. Config it by yourself.</property>
              </object>
              <packing>
                <property name="position">11</property>
              </packing>
            </child>
            <child>
              <object class="GtkFileChooserButton" id="bfcFontFile">
                <property name="visible">True</property>
                <property name="create_folders">False</property>
                <property name="filter">tarzipFilter</property>
              </object>
              <packing>
                <property name="position">12</property>
              </packing>
            </child>
            <child>
              <object class="GtkHSeparator" id="hseparator1">
                <property name="visible">True</property>
              </object>
              <packing>
                <property name="expand">False</property>
                <property name="padding">8</property>
                <property name="position">13</property>
              </packing>
            </child>
            <child>
              <object class="GtkHBox" id="hbox1">
                <property name="visible">True</property>
                <child>
                  <object class="GtkButton" id="btnGDM">
                    <property name="label" translatable="yes">GDM Setting</property>
                    <property name="width_request">160</property>
                    <property name="visible">True</property>
                    <property name="can_focus">True</property>
                    <property name="receives_default">True</property>
                    <signal name="clicked" handler="on_btnGDM_clicked"/>
                  </object>
                  <packing>
                    <property name="padding">8</property>
                    <property name="position">0</property>
                  </packing>
                </child>
                <child>
                  <object class="GtkButton" id="btnPlymouth">
                    <property name="label" translatable="yes">Plymouth Setting</property>
                    <property name="width_request">160</property>
                    <property name="visible">True</property>
                    <property name="can_focus">True</property>
                    <property name="receives_default">True</property>
                    <signal name="clicked" handler="on_btnPlymouth_clicked"/>
                  </object>
                  <packing>
                    <property name="padding">8</property>
                    <property name="position">1</property>
                  </packing>
                </child>
              </object>
              <packing>
                <property name="position">14</property>
              </packing>
            </child>
          </object>
          <packing>
            <property name="position">1</property>
          </packing>
        </child>
        <child internal-child="action_area">
          <object class="GtkHButtonBox" id="dialog-action_area1">
            <property name="visible">True</property>
            <property name="layout_style">end</property>
            <child>
              <object class="GtkButton" id="btnCancel">
                <property name="label">gtk-cancel</property>
                <property name="visible">True</property>
                <property name="can_focus">True</property>
                <property name="receives_default">True</property>
                <property name="use_stock">True</property>
                <signal name="clicked" handler="on_btnCancel_clicked"/>
              </object>
              <packing>
                <property name="expand">False</property>
                <property name="fill">False</property>
                <property name="position">0</property>
              </packing>
            </child>
            <child>
              <object class="GtkButton" id="btnOK">
                <property name="label">gtk-apply</property>
                <property name="visible">True</property>
                <property name="can_focus">True</property>
                <property name="receives_default">True</property>
                <property name="use_stock">True</property>
                <signal name="clicked" handler="on_btnOK_clicked"/>
              </object>
              <packing>
                <property name="expand">False</property>
                <property name="fill">False</property>
                <property name="position">1</property>
              </packing>
            </child>
          </object>
          <packing>
            <property name="expand">False</property>
            <property name="pack_type">end</property>
            <property name="position">0</property>
          </packing>
        </child>
      </object>
    </child>
    <action-widgets>
      <action-widget response="0">btnCancel</action-widget>
      <action-widget response="0">btnOK</action-widget>
    </action-widgets>
  </object>
  <object class="GtkFileFilter" id="tarFilter"/>
  <object class="GtkFileFilter" id="pictFilter"/>
  <object class="GtkFileFilter" id="tarzipFilter"/>
</interface>
"""
gdm_data = """<?xml version="1.0"?>
<interface>
  <requires lib="gtk+" version="2.16"/>
  <!-- interface-naming-policy project-wide -->
  <object class="GtkDialog" id="GDMSetup">
    <property name="border_width">5</property>
    <property name="title" translatable="yes">GDM setup</property>
    <property name="resizable">False</property>
    <property name="window_position">center</property>
    <property name="type_hint">normal</property>
    <property name="has_separator">False</property>
    <signal name="close" handler="on_GDMSetup_close"/>
    <child internal-child="vbox">
      <object class="GtkVBox" id="dialog-vbox1">
        <property name="visible">True</property>
        <property name="spacing">2</property>
        <child>
          <object class="GtkVBox" id="vbox1">
            <property name="visible">True</property>
            <child>
              <object class="GtkLabel" id="label1">
                <property name="visible">True</property>
                <property name="xalign">0</property>
                <property name="label" translatable="yes">Select the Icon Set file for the Login Window (.tar.gz)
*The name of the uncompressed folder must be the same as the archive.</property>
              </object>
              <packing>
                <property name="position">0</property>
              </packing>
            </child>
            <child>
              <object class="GtkFileChooserButton" id="bfcGDMIconFile">
                <property name="visible">True</property>
                <property name="create_folders">False</property>
              </object>
              <packing>
                <property name="position">1</property>
              </packing>
            </child>
            <child>
              <object class="GtkLabel" id="label2">
                <property name="visible">True</property>
                <property name="xalign">0</property>
                <property name="label" translatable="yes">Select the GDM Theme file for the Login Window (.tar.gz)
*The name of the uncompressed folder must be the same as the archive.</property>
              </object>
              <packing>
                <property name="position">2</property>
              </packing>
            </child>
            <child>
              <object class="GtkFileChooserButton" id="bfcGDMThemeFile">
                <property name="visible">True</property>
                <property name="create_folders">False</property>
              </object>
              <packing>
                <property name="position">3</property>
              </packing>
            </child>
            <child>
              <object class="GtkLabel" id="label3">
                <property name="visible">True</property>
                <property name="xalign">0</property>
                <property name="label" translatable="yes">Select the Wallpaper file for the background of the Login Window (.jpg/.png)</property>
              </object>
              <packing>
                <property name="position">4</property>
              </packing>
            </child>
            <child>
              <object class="GtkFileChooserButton" id="bfcGDMWallPaperFile">
                <property name="visible">True</property>
              </object>
              <packing>
                <property name="position">5</property>
              </packing>
            </child>
            <child>
              <object class="GtkHBox" id="hbox1">
                <property name="visible">True</property>
                <child>
                  <object class="GtkLabel" id="label4">
                    <property name="visible">True</property>
                    <property name="xalign">0</property>
                    <property name="label" translatable="yes">Open the "Login Window Preferences&#x201D;</property>
                  </object>
                  <packing>
                    <property name="position">0</property>
                  </packing>
                </child>
                <child>
                  <object class="GtkButton" id="btnGDMProp">
                    <property name="label" translatable="yes">Open</property>
                    <property name="visible">True</property>
                    <property name="can_focus">True</property>
                    <property name="receives_default">True</property>
                    <signal name="clicked" handler="on_btnGDMProp_clicked"/>
                  </object>
                  <packing>
                    <property name="position">1</property>
                  </packing>
                </child>
              </object>
              <packing>
                <property name="position">6</property>
              </packing>
            </child>
          </object>
          <packing>
            <property name="position">1</property>
          </packing>
        </child>
        <child internal-child="action_area">
          <object class="GtkHButtonBox" id="dialog-action_area1">
            <property name="visible">True</property>
            <property name="layout_style">end</property>
            <child>
              <object class="GtkButton" id="btnGDMCancel">
                <property name="label">gtk-cancel</property>
                <property name="visible">True</property>
                <property name="can_focus">True</property>
                <property name="receives_default">True</property>
                <property name="use_stock">True</property>
                <signal name="clicked" handler="on_btnGDMCancel_clicked"/>
              </object>
              <packing>
                <property name="expand">False</property>
                <property name="fill">False</property>
                <property name="position">0</property>
              </packing>
            </child>
            <child>
              <object class="GtkButton" id="btnGDMOK">
                <property name="label">gtk-ok</property>
                <property name="visible">True</property>
                <property name="can_focus">True</property>
                <property name="receives_default">True</property>
                <property name="use_stock">True</property>
                <signal name="clicked" handler="on_btnGDMOK_clicked"/>
              </object>
              <packing>
                <property name="expand">False</property>
                <property name="fill">False</property>
                <property name="position">1</property>
              </packing>
            </child>
          </object>
          <packing>
            <property name="expand">False</property>
            <property name="pack_type">end</property>
            <property name="position">0</property>
          </packing>
        </child>
      </object>
    </child>
    <action-widgets>
      <action-widget response="0">btnGDMCancel</action-widget>
      <action-widget response="0">btnGDMOK</action-widget>
    </action-widgets>
  </object>
</interface>
"""
ply_data = """<?xml version="1.0"?>
<interface>
  <requires lib="gtk+" version="2.16"/>
  <!-- interface-naming-policy project-wide -->
  <object class="GtkDialog" id="PlymouthSetup">
    <property name="border_width">5</property>
    <property name="title" translatable="yes">Plymouth Setting</property>
    <property name="resizable">False</property>
    <property name="window_position">center</property>
    <property name="type_hint">normal</property>
    <property name="has_separator">False</property>
    <signal name="close" handler="on_PlymouthSetup_close"/>
    <child internal-child="vbox">
      <object class="GtkVBox" id="dialog-vbox1">
        <property name="visible">True</property>
        <property name="spacing">2</property>
        <child>
          <object class="GtkVBox" id="vbox1">
            <property name="visible">True</property>
            <child>
              <object class="GtkLabel" id="label1">
                <property name="visible">True</property>
                <property name="xalign">0</property>
                <property name="label" translatable="yes">Select the Plymouth Theme file (.tar.gz)
*The name of the uncompressed folder must be the same as the archive.
Also, the .plymouth file in the uncompressed folder must be the same name.</property>
              </object>
              <packing>
                <property name="position">0</property>
              </packing>
            </child>
            <child>
              <object class="GtkFileChooserButton" id="bfcPlymouthTheme">
                <property name="visible">True</property>
                <property name="create_folders">False</property>
              </object>
              <packing>
                <property name="position">1</property>
              </packing>
            </child>
          </object>
          <packing>
            <property name="position">1</property>
          </packing>
        </child>
        <child internal-child="action_area">
          <object class="GtkHButtonBox" id="dialog-action_area1">
            <property name="visible">True</property>
            <property name="layout_style">end</property>
            <child>
              <object class="GtkButton" id="btnPlyCancel">
                <property name="label">gtk-cancel</property>
                <property name="visible">True</property>
                <property name="can_focus">True</property>
                <property name="receives_default">True</property>
                <property name="use_stock">True</property>
                <signal name="clicked" handler="on_btnPlyCancel_clicked"/>
              </object>
              <packing>
                <property name="expand">False</property>
                <property name="fill">False</property>
                <property name="position">0</property>
              </packing>
            </child>
            <child>
              <object class="GtkButton" id="btnPlyOK">
                <property name="label">gtk-ok</property>
                <property name="visible">True</property>
                <property name="can_focus">True</property>
                <property name="receives_default">True</property>
                <property name="use_stock">True</property>
                <signal name="clicked" handler="on_btnPlyOK_clicked"/>
              </object>
              <packing>
                <property name="expand">False</property>
                <property name="fill">False</property>
                <property name="position">1</property>
              </packing>
            </child>
          </object>
          <packing>
            <property name="expand">False</property>
            <property name="pack_type">end</property>
            <property name="position">0</property>
          </packing>
        </child>
      </object>
    </child>
    <action-widgets>
      <action-widget response="0">btnPlyCancel</action-widget>
      <action-widget response="0">btnPlyOK</action-widget>
    </action-widgets>
  </object>
</interface>
"""
ext_data = """<?xml version="1.0"?>
<interface>
  <requires lib="gtk+" version="2.16"/>
  <!-- interface-naming-policy project-wide -->
  <object class="GtkWindow" id="NowSetup">
    <property name="title" translatable="yes">moe setup</property>
    <property name="resizable">False</property>
    <property name="window_position">center-always</property>
    <property name="skip_taskbar_hint">True</property>
    <child>
      <object class="GtkVBox" id="vbox1">
        <property name="visible">True</property>
        <child>
          <object class="GtkLabel" id="label1">
            <property name="visible">True</property>
            <property name="xpad">16</property>
            <property name="ypad">16</property>
            <property name="label" translatable="yes">Performing post-configuration tasks.
Please wait for a while.</property>
          </object>
          <packing>
            <property name="position">0</property>
          </packing>
        </child>
      </object>
    </child>
  </object>
</interface>
"""
class MoeSetupApp:

    def __init__(self):

        #ログファイルの設定
        logging.basicConfig(level=LOGLEVEL,
            format='%(asctime)s %(levelname)s %(message)s',
            filename='/tmp/moesetup.log',
            filemode='w')

        #Set the Glade file
        self.gladefile = "moesetup.ui"
        self.wTree = gtk.Builder()
        #self.wTree.add_from_file(os.path.dirname(os.path.abspath(__file__)) + "/"+self.gladefile)
        self.wTree.add_from_string(xml_data)
        #Create our dictionay and connect it
        dic = {"on_btnPlymouth_clicked" : self.on_btnPlymouth_clicked,
                "on_btnGDM_clicked" : self.on_btnGDM_clicked,
                "on_btnCancel_clicked" : self.on_btnCancel_clicked,
                "on_btnOK_clicked" : self.on_btnOK_clicked,
                "on_MainWindow_destroy" : self.on_MainWindow_destroy }
        #フィルタの作成
        self.allFilter = gtk.FileFilter()
        self.tarFilter = self.wTree.get_object("tarFilter")
        self.pictFilter = self.wTree.get_object("pictFilter")
        self.tarzipFilter = self.wTree.get_object("tarzipFilter")
        
        self.allFilter.set_name("All of the Files")
        self.allFilter.add_pattern("*")

        self.tarFilter.set_name("tar.gz Archives")
        self.tarFilter.add_pattern("*.tar.gz")

        self.pictFilter.set_name("Image Files")
        self.pictFilter.add_pattern("*.jpg")
        self.pictFilter.add_pattern("*.png")

        self.tarzipFilter.set_name("Font Archives")
        self.tarzipFilter.add_pattern("*.tar.gz")
        self.tarzipFilter.add_pattern("*.zip")

        self.themeFile = self.wTree.get_object("bfcThemeFile")
        self.themeFile.add_filter(self.tarFilter)
        self.themeFile.add_filter(self.allFilter)
        self.themeFile.set_filter(self.tarFilter)

        self.iconThemeFile = self.wTree.get_object("bfcIconThemeFile")
        self.iconThemeFile.add_filter(self.tarFilter)
        self.iconThemeFile.add_filter(self.allFilter)
        self.iconThemeFile.set_filter(self.tarFilter)

        self.wallpaperFile = self.wTree.get_object("bfcWallPaperFile")
        self.wallpaperFile.add_filter(self.pictFilter)
        self.wallpaperFile.add_filter(self.allFilter)
        self.wallpaperFile.set_filter(self.pictFilter)

        self.nbgFile = self.wTree.get_object("bfcNBGFile")
        self.nbgFile.add_filter(self.pictFilter)
        self.nbgFile.add_filter(self.allFilter)
        self.nbgFile.set_filter(self.pictFilter)

        self.soundThemeFile = self.wTree.get_object("bfcSoundThemeFile")
        self.soundThemeFile.add_filter(self.tarFilter)
        self.soundThemeFile.add_filter(self.allFilter)
        self.soundThemeFile.set_filter(self.tarFilter)

        self.fontFile = self.wTree.get_object("bfcFontFile")
        self.fontFile.add_filter(self.tarzipFilter)
        self.fontFile.add_filter(self.allFilter)
        self.fontFile.set_filter(self.tarzipFilter)

        self.plymouthBtn = self.wTree.get_object("btnPlymouth")
        self.wTree.connect_signals(dic)

        #Set the Glade file
        self.gdmgladefile = "moegdmsetup.ui"
        self.wGDMTree = gtk.Builder()
        #self.wGDMTree.add_from_file(os.path.dirname(os.path.abspath(__file__)) + "/"+self.gdmgladefile)
        self.wGDMTree.add_from_string(gdm_data)
        #Create our dictionay and connect it
        gdmdic = {"on_btnGDMProp_clicked" : self.on_btnGDMProp_clicked,
                "on_btnGDMCancel_clicked" : self.on_btnGDMCancel_clicked,
                "on_btnGDMOK_clicked" : self.on_btnGDMOK_clicked,
                "on_GDMSetup_close" : self.on_btnGDMCancel_clicked }
        self.GDMThemeFile = self.wGDMTree.get_object("bfcGDMThemeFile")
        self.GDMThemeFile.add_filter(self.tarFilter)
        self.GDMThemeFile.add_filter(self.allFilter)
        self.GDMThemeFile.set_filter(self.tarFilter)

        self.GDMIconFile = self.wGDMTree.get_object("bfcGDMIconFile")
        self.GDMIconFile.add_filter(self.tarFilter)
        self.GDMIconFile.add_filter(self.allFilter)
        self.GDMIconFile.set_filter(self.tarFilter)

        self.GDMWallpaperFile = self.wGDMTree.get_object("bfcGDMWallPaperFile")
        self.GDMWallpaperFile.add_filter(self.pictFilter)
        self.GDMWallpaperFile.add_filter(self.allFilter)
        self.GDMWallpaperFile.set_filter(self.pictFilter)

        self.wGDMTree.connect_signals(gdmdic)
        self.gdmPropBtn = self.wGDMTree.get_object("btnGDMProp")

        #Set the Glade file
        self.plygladefile = "moeplysetup.ui"
        self.wPlyTree = gtk.Builder()
        #self.wPlyTree.add_from_file(os.path.dirname(os.path.abspath(__file__)) + "/"+self.plygladefile)
        self.wPlyTree.add_from_string(ply_data)
        #Create our dictionay and connect it
        Plydic = {"on_btnPlyCancel_clicked" : self.on_btnPlyCancel_clicked,
                "on_btnPlyOK_clicked" : self.on_btnPlyOK_clicked,
                "on_PlymouthSetup_close" : self.on_btnPlyCancel_clicked }
        self.PlyThemeFile = self.wPlyTree.get_object("bfcPlymouthTheme")
        self.PlyThemeFile.add_filter(self.tarFilter)
        self.PlyThemeFile.add_filter(self.allFilter)
        self.PlyThemeFile.set_filter(self.tarFilter)
        self.wPlyTree.connect_signals(Plydic)

        #Set the Glade file
        self.extgladefile = "moeexit.ui"
        self.wExtTree = gtk.Builder()
        #self.wExtTree.add_from_file(os.path.dirname(os.path.abspath(__file__)) + "/"+self.extgladefile)
        self.wExtTree.add_from_string(ext_data)

        #アプリケーションの初期化
        if self.checkUbuntuVer() < 10.04:
            self.plymouthBtn.hide()
        if self.checkUbuntuVer() >= 11.04:
            self.gdmPropBtn.hide()

        self.mainWindow = self.wTree.get_object ("MainWindow")
        self.gdmWindow = self.wGDMTree.get_object ("GDMSetup")
        self.plyWindow = self.wPlyTree.get_object ("PlymouthSetup")
        self.extWindow = self.wExtTree.get_object ("NowSetup")

    def on_MainWindow_destroy(self, widget):
        debuglog("QUIT")
        gtk.main_quit()

    def on_btnCancel_clicked(self,widget):
        debuglog("Cansel")
        gtk.main_quit()

    def on_btnGDMProp_clicked(self,widget):
        debuglog("GDMProp")
        if UBUNTU_VERSION >= 10.10:
            self.sudoCommand("xhost +SI:localuser:gdm","",True)
        self.sudoCommand("dbus-launch gnome-appearance-properties","-u gdm",True)
        if UBUNTU_VERSION >= 10.10:
            self.sudoCommand("xhost +SI:localuser:gdm","",True)
        
    def on_btnGDMCancel_clicked(self,widget):
        debuglog("GDMCansel")
        self.GDMThemeFile.unselect_all()
        self.GDMIconFile.unselect_all()
        self.GDMWallpaperFile.unselect_all()
        self.gdmWindow.hide()

    def on_btnGDMOK_clicked(self,widget):
        debuglog("GDMOK")
        self.gdmWindow.hide()

    def on_btnGDM_clicked(self,widget):
        debuglog("GDMClick")
        self.gdmWindow.show()

    def on_btnPlymouth_clicked(self,widget):
        debuglog("PlymouthClick")
        self.plyWindow.show()

    def on_btnPlyOK_clicked(self,widget):
        debuglog("PlyOKClick")
        self.plyWindow.hide()

    def on_btnPlyCancel_clicked(self,widget):
        debuglog("PlyCansel")
        self.PlyThemeFile.unselect_all()
        self.plyWindow.hide()

    def on_btnOK_clicked(self,widget):
        debuglog("OK")
        self.extWindow.show_all()
        time.sleep(0.2)
        while gtk.events_pending():
            gtk.main_iteration(1)
        time.sleep(0.2)
        while gtk.events_pending():
            gtk.main_iteration(1)
        #展開先のパスを取得
        theme_path = os.path.expanduser("~/.themes")
        icon_path = os.path.expanduser("~/.icons")
        nbg_path = os.path.expanduser("~/.nautilus/patterns")
        sound_path = os.path.expanduser("~/.local/share/sounds")
        font_path = os.path.expanduser("~/.fonts")
        #必要に応じて展開先パスを作成
        self.checkPath(theme_path)
        self.checkPath(icon_path)
        self.checkPath(nbg_path)
        self.checkPath(sound_path)
        self.checkPath(font_path)
        #ファイルの展開とコピー
        #GTKテーマ設定
        filename = self.themeFile.get_filename()
        if filename != None and len(filename) > 0:
            self.extracltTar(filename, theme_path)
            param = os.path.basename(filename)
            tmp = param.split(".")
            param = tmp[0]
            self.setTheme("/desktop/gnome/interface/gtk_theme",param)
            self.setTheme("/apps/metacity/general/theme",param)
            filename = ""
        #アイコンテーマ設定
        filename = self.iconThemeFile.get_filename()
        if filename != None and len(filename) > 0:
            self.extracltTar(filename, icon_path)
            param = os.path.basename(filename)
            tmp = param.split(".")
            param = tmp[0]
            self.setTheme("/desktop/gnome/interface/icon_theme",param)
            filename = ""
        #壁紙設定
        filename = self.wallpaperFile.get_filename()
        if filename != None and len(filename) > 0:
            self.themeCommand("/desktop/gnome/background/picture_filename",filename)
            filename = ""
        #Nautilus背景設定
        filename = self.nbgFile.get_filename()
        if filename != None and len(filename) > 0:
            param = os.path.basename(filename)
            shutil.copyfile(filename,nbg_path+"/"+param)
            self.setThemeBool("/apps/nautilus/preferences/background_set","True")
            self.setTheme("/apps/nautilus/preferences/background_filename","file://"+nbg_path+"/"+param)
            filename = ""
        #サウンドテーマ設定
        filename = self.soundThemeFile.get_filename()
        if filename != None and len(filename) > 0:
            self.extracltTar(filename, sound_path)
            param = os.path.basename(filename)
            tmp = param.split(".")
            param = tmp[0]
            self.setTheme("/desktop/gnome/sound/theme_name",param)
            filename = ""
        #フォント設定
        filename = self.fontFile.get_filename()
        if filename != None and len(filename) > 0:
            param = os.path.basename(filename)
            tmp = param.split(".")
            if len(tmp) > 1:
                tmp[1] =  tmp[1].lower()
            if tmp[1] == "zip":
                self.extracltZip(filename, font_path)
            else:
                self.extracltTar(filename, font_path)
            filename = ""
        #gdm
        #gdmアイコン設定
        filename = self.GDMIconFile.get_filename()
        if filename != None and len(filename) > 0:
            self.sudoCommand("mkdir --parents /var/lib/gdm/.icons","",True)
            self.sudoCommand("tar zxvfC "+ filename +" /var/lib/gdm/.icons","",True)
            param = os.path.basename(filename)
            tmp = param.split(".")
            param = tmp[0]
            if UBUNTU_VERSION >= 11.04:
                self.sudoCommand("gconftool-2 --direct --config-source=xml:readwrite:/var/lib/gdm/Seat1/.gconf -s -t string /desktop/gnome/interface/icon_theme " + param,"-u gdm ", True )
            else:
                self.setGDMThemeCommand("/desktop/gnome/interface/icon_theme",param)
            filename = ""
        #gdm壁紙設定
        filename = self.GDMWallpaperFile.get_filename()
        if filename != None and len(filename) > 0:
            if UBUNTU_VERSION >= 11.04:
                self.sudoCommand("gconftool-2 --direct --config-source=xml:readwrite:/var/lib/gdm/Seat1/.gconf -s -t string /desktop/gnome/background/picture_options scaled " + param,"-u gdm ", True )
                self.sudoCommand("gconftool-2 --direct --config-source=xml:readwrite:/var/lib/gdm/Seat1/.gconf -s -t string /desktop/gnome/background/picture_filename " + filename,"-u gdm ", True )
            else:
                self.setGDMTheme("/desktop/gnome/background/picture_options","scaled")
                self.setGDMThemeCommand("/desktop/gnome/background/picture_filename",filename)
            filename = ""
        #gdmテーマ設定
        filename = self.GDMThemeFile.get_filename()
        if filename != None and len(filename) > 0:
            self.sudoCommand("mkdir --parents /var/lib/gdm/.themes","",True)
            self.sudoCommand('tar zxvfC '+ filename + ' /var/lib/gdm/.themes',"",True)
            param = os.path.basename(filename)
            tmp = param.split(".")
            param = tmp[0]
            if UBUNTU_VERSION >= 11.04:
                self.sudoCommand("gconftool-2 --direct --config-source=xml:readwrite:/var/lib/gdm/Seat1/.gconf -s -t string /desktop/gnome/interface/gtk_theme " + param,"-u gdm ", True )
                self.sudoCommand("gconftool-2 --direct --config-source=xml:readwrite:/var/lib/gdm/Seat1/.gconf -s -t string /apps/metacity/general/theme " + param,"-u gdm ", True )
            else:
                self.setGDMThemeCommand("/desktop/gnome/interface/gtk_theme",param)
            filename = ""
        #ぷります
        #プリマステーマ設定
        filename = self.PlyThemeFile.get_filename()
        if filename != None and len(filename) > 0:
            self.sudoCommand('tar zxvfC "'+ filename + '" /lib/plymouth/themes',"",True)
            param = os.path.basename(filename)
            tmp = param.split(".")
            param = tmp[0]
            random.seed()
            rnd = random.randint(0,9999)
            self.sudoCommand("update-alternatives --install /lib/plymouth/themes/default.plymouth default.plymouth /lib/plymouth/themes/"+param+"/"+param+".plymouth "+str(rnd),"",True)
            self.sudoCommand("update-alternatives --set default.plymouth /lib/plymouth/themes/"+param+"/"+param+".plymouth","",True)
            time.sleep(0.2)
            while gtk.events_pending():
                gtk.main_iteration(1)
            time.sleep(0.2)
            while gtk.events_pending():
                gtk.main_iteration(1)
            self.sudoCommand("update-initramfs -u -k all","",True)
        if UBUNTU_VERSION >= 11.04:
            ret = commands.getoutput("chmod +x /tmp/moesetup.sh")
            ret = commands.getoutput("gksudo /tmp/moesetup.sh")
            ret = commands.getoutput("rm /tmp/moesetup.sh")

        gtk.main_quit()

    def checkPath(self,path):
        debuglog(path)
        if os.path.exists(path) == False:
            os.makedirs(path)

    def extracltTar(self,tarFile,distPath):
        arc_file = tarfile.open(tarFile)
        arc_file.extractall(distPath)
        arc_file.close()

    def extracltZip(self,zipFile,distPath):
        cmd = 'unzip "'+ zipFile +'" -d ' + distPath
        print cmd
        ret = commands.getoutput(cmd)

    def setTheme(self,command,param):
        debuglog(command)
        debuglog(param)
        retcall = subprocess.Popen(["gconftool-2", "-s", command,"-t", "string", param], stdout=subprocess.PIPE)
        return retcall.stdout.readline().strip('\n')

    def themeCommand(self,command,param):
        debuglog(command)
        debuglog(param)
        cmd = 'gconftool-2 -s '+command + ' -t string "' + param +'"'
        print cmd
        ret = commands.getoutput(cmd)
        return ret

    def setThemeBool(self,command,param):
        retcall = subprocess.Popen(["gconftool-2", "-s", command,"-t", "bool", param], stdout=subprocess.PIPE)
        return retcall.stdout.readline().strip('\n')

    def setGDMTheme(self,command,param):
        debuglog(command)
        debuglog(param)
        retcall = subprocess.Popen(["gksudo","-u","gdm","gconftool-2", "-s", command,"-t", "string", param], stdout=subprocess.PIPE)
        return retcall.stdout.readline().strip('\n')

    def setGDMThemeCommand(self,command,param):
        debuglog(command)
        debuglog(param)
        cmd = 'sudo -u gdm gconftool-2 -s '+command + ' -t string "' + param +'"'
        print cmd
        ret = commands.getoutput(cmd)
        return ret

    def sudoCommand(self,command,user,useEscape):
        debuglog(command)
        if UBUNTU_VERSION >= 11.04:
            if os.path.exists("/tmp/moesetup.sh") == False:
                f = open("/tmp/moesetup.sh","w")
                str = "#!/bin/sh\n"
                f.write(str)
            else:
                f = open("/tmp/moesetup.sh","a")
        if useEscape == True:
            cmd = 'gksudo ' + user + ' -k "'+command + '"'
        else:
            cmd = 'gksudo ' + user + ' -k ' + command

        print cmd
        if UBUNTU_VERSION >= 11.04:
            str = cmd + "\n"
            f.write(str)
        else:
            ret = commands.getoutput(cmd)
            debuglog(ret)
            return ret
        if UBUNTU_VERSION >= 11.04:
            f.close()

    def checkUbuntuVer(self):
        retcall = subprocess.Popen(["lsb_release","-r"], stdout=subprocess.PIPE)
        ret = retcall.stdout.readline().strip('\n')
        ver = ret.split("\t")
        print ver
        return float(ver[1])


def debuglog(msg):
    if LOGLEVEL == logging.DEBUG:
        print msg
    logging.debug(msg)

def error_dialog(pwin, msg):
    dialog = gtk.MessageDialog(
            parent = pwin,
            flags = gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
            type = gtk.MESSAGE_ERROR,
            buttons = gtk.BUTTONS_CLOSE,
            message_format = msg)
    r = dialog.run()
    dialog.hide()
    dialog.destroy()
    #イベントを回してウィンドウが消えるようにする。
    while gtk.events_pending():
        gtk.main_iteration(1)
    return r

if __name__ == "__main__":
    ret = commands.getoutput("lsb_release -r | cut -f 2")
    print ret
    UBUNTU_VERSION = float(ret)
    MoeSetupApp()
    gtk.main()
